
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.awt.image.PixelGrabber;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.*;

public class JFrame1 extends JFrame implements ActionListener {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5373301387398455L;
	public BufferedImage image1;
	public BufferedImage image2;
	public BufferedImage image3;
	public BufferedImage image4;
	public BufferedImage image5;
	
	public BufferedImage pa1;
	public BufferedImage pa2;
	public BufferedImage pa3;
	public BufferedImage pa4;
	public BufferedImage pa5;
	public BufferedImage pa6;
	public BufferedImage pa7;
	public BufferedImage pa8;
	public BufferedImage pa9;
	public BufferedImage pa10;
	public BufferedImage pa11;
	public BufferedImage pa12;
	public BufferedImage pa13;
	

	public int[] patternX;
	public int[] patternY;
	public int[] st1;
	public int[] ed1;
	public int[] frameX;
	public int[] frameY;
	public int[] frameW;
	public int[] frameH;
	public int[] st2;
	public int[] ed2;
	
	public int ntX;
	public int ntY;
	
	public String[] saPai;
	public String[] sbPai;

	public double[] prob1;
	public double[] prob2;
	public double[] prob3;
	
	public int top1;
	public int top2;
	public int top3;
	
	
	public int bottom1;
	public int bottom2;
	public int bottom3;
	
	public int left1;
	public int left2;
	public int left3;
	
	public int right1;
	public int right2;
	public int right3;
	
	public int pWidth1;
	public int pWidth2;
	public int pWidth3;
	
	public int pHeight1;
	public int pHeight2;
	public int pHeight3;

	public int ukPai = 0;
	public int[] No;
	
	public final int WIDTH = 320;
	public final int HEIGHT = 50;
	public final int PWIDTH = 30;;
	public final int PHEIGHT = 50;
	public final int SWIDTH = 24;
	public final int SHEIGHT = 32;
	public final int NPAI = 35;
	public final int GWIDTH = 60;
	public final int GHEIGHT = 60;
	
	public final int BNC = 7;
	public final int THR = 133;
	public final int THG = 158;
	public final int THB = 168;
	
	public final int NP = 13;
	
	public final int WHITE = 255*256*256+255*256+255;
	public final int RED = 255*256*256;
	public final double RATE = 1.0;
	
	public int[] pxd1;
	public int[] pxd2;
	public int[] pxd3;
	public int[] pxd4;
	public int[] pxd5;
	public int[] pxd6;
	public int[] pxd7;
	public int[] pxd8;
	public int[] pxd9;
	public int[] pxd10;
	
	public String text = "";
	public String comment ="";
	

	public JPanel p1;
	public JPanel p2;
	public JPanel p3;
	
	public JLabel l1;
	public JLabel l2;
	public JLabel l3;
	public JLabel l4;
	public JLabel l5;
	
	public JLabel la1;
	public JLabel la2;
	public JLabel la3;
	public JLabel la4;
	public JLabel la5;
	public JLabel la6;
	public JLabel la7;
	public JLabel la8;
	public JLabel la9;
	public JLabel la10;
	public JLabel la11;
	public JLabel la12;
	public JLabel la13;


	public JButton b1;
	public JButton b2;
	
	
	public JTextArea ta1;
	public JTextArea ta2;
	public JMenuItem menuExit;
	public String[] figure;
	public String[] kanji;
	public Graphics g1;
	public Graphics g2;
	public Graphics g3;
	public Graphics g4;
	public Graphics g5;
	
	public Graphics ga1;
	public Graphics ga2;
	public Graphics ga3;
	public Graphics ga4;
	public Graphics ga5;
	public Graphics ga6;
	public Graphics ga7;
	public Graphics ga8;
	public Graphics ga9;
	public Graphics ga10;
	public Graphics ga11;
	public Graphics ga12;
	public Graphics ga13;


	public static void main(String[] args){
		new JFrame1("MAJAN PAI Recognition");
	}
	
	public JFrame1(String title)  {
		super(title);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		
		pxd1 = new int[WIDTH * HEIGHT];
		pxd2 = new int[WIDTH * HEIGHT];
		pxd3 = new int[PWIDTH * PHEIGHT];
		pxd4 = new int[PWIDTH * PHEIGHT];
		pxd5 = new int[PWIDTH * PHEIGHT];
		pxd6 = new int[PWIDTH * PHEIGHT];
		pxd7 = new int[PWIDTH * PHEIGHT];
		pxd8 = new int[PWIDTH * PHEIGHT];
		pxd9 = new int[PWIDTH * PHEIGHT];
		pxd10 = new int[PWIDTH * PHEIGHT];
		
		patternX = new int[HEIGHT];
		patternY = new int[WIDTH];
		st1 = new int[WIDTH];
		ed1 = new int[WIDTH];
		frameX = new int[NP+1];
		frameY = new int[NP+1];
		frameW = new int[NP+1];
		frameH = new int[NP+1];
		
		st2 = new int[HEIGHT];
		ed2 = new int[HEIGHT];
		
		saPai = new String[NPAI];
		sbPai = new String[NPAI];

		prob1 = new double[NPAI];
		prob2 = new double[NPAI];
		prob3 = new double[NPAI];
		No = new int[NPAI];
		for (int i = 0; i < 35; i++){
			saPai[i]= "a"+ i +".bmp";
			sbPai[i]= "b"+ i +".bmp";
		}
	
		image1 = new BufferedImage(WIDTH, HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		image2 = new BufferedImage(WIDTH, HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		image3 = new BufferedImage(PWIDTH, PHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		image4 = new BufferedImage(WIDTH, GHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		image5 = new BufferedImage(GWIDTH, HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 

		pa1 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa2 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa3 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa4 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa5 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa6 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa7 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa8 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa9 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa10 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa11 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa12 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pa13 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		
		JPanel p1 = new JPanel();
		p1.setLayout(null);
		p1.setBackground(new Color(144,238,144));

		preparePai(WIDTH, HEIGHT, image1, g1);
		l1 = new JLabel(new ImageIcon(image1));
		l1.setBounds(20,80,WIDTH,HEIGHT);
		p1.add(l1);

		preparePai(WIDTH, HEIGHT, image2, g2);
		l2 = new JLabel(new ImageIcon(image2));
		l2.setBounds(350,80,WIDTH, HEIGHT);
		p1.add(l2);
		
		preparePai(PWIDTH, PHEIGHT, image3, g3);
		l3 = new JLabel(new ImageIcon(image3));
		l3.setBounds(695,10,PWIDTH, PHEIGHT);
		p1.add(l3);
		
		preparePai(WIDTH, GHEIGHT, image4, g4);
		l4 = new JLabel(new ImageIcon(image4));
		l4.setBounds(350,10,WIDTH, GHEIGHT);
		p1.add(l4);
		
		preparePai(GWIDTH, HEIGHT, image5, g5);
		l5 = new JLabel(new ImageIcon(image5));
		l5.setBounds(680,80,GWIDTH, HEIGHT);
		p1.add(l5);

		preparePai(SWIDTH, SHEIGHT, pa1, ga1);
		la1 = new JLabel(new ImageIcon(pa1));
		la1.setBounds(780,80,SWIDTH, SHEIGHT);
		p1.add(la1);
		
		preparePai(SWIDTH, SHEIGHT, pa2, ga2);
		la2 = new JLabel(new ImageIcon(pa2));
		la2.setBounds(820,80,SWIDTH, SHEIGHT);
		p1.add(la2);
		
		preparePai(SWIDTH, SHEIGHT,pa3, ga3);
		la3 = new JLabel(new ImageIcon(pa3));
		la3.setBounds(860,80,SWIDTH, SHEIGHT);
		p1.add(la3);
		
		preparePai(SWIDTH, SHEIGHT,pa4, ga4);
		la4 = new JLabel(new ImageIcon(pa4));
		la4.setBounds(900,80,SWIDTH, SHEIGHT);
		p1.add(la4);
		
		preparePai(SWIDTH, SHEIGHT,pa5, ga5);
		la5 = new JLabel(new ImageIcon(pa5));
		la5.setBounds(940,80,SWIDTH, SHEIGHT);
		p1.add(la5);

		preparePai(SWIDTH, SHEIGHT,pa6, ga6);
		la6 = new JLabel(new ImageIcon(pa6));
		la6.setBounds(980,80,SWIDTH, SHEIGHT);
		p1.add(la6);

		preparePai(SWIDTH, SHEIGHT,pa7, ga7);
		la7 = new JLabel(new ImageIcon(pa7));
		la7.setBounds(1020,80,SWIDTH, SHEIGHT);
		p1.add(la7);
		
		preparePai(SWIDTH, SHEIGHT,pa8, ga8);
		la8 = new JLabel(new ImageIcon(pa8));
		la8.setBounds(1060,80,SWIDTH, SHEIGHT);
		p1.add(la8);
		
		preparePai(SWIDTH, SHEIGHT,pa9, ga9);
		la9 = new JLabel(new ImageIcon(pa9));
		la9.setBounds(1100,80,SWIDTH, SHEIGHT);
		p1.add(la9);
		
		preparePai(SWIDTH, SHEIGHT,pa10, ga10);
		la10 = new JLabel(new ImageIcon(pa10));
		la10.setBounds(1140,80,SWIDTH, SHEIGHT);
		p1.add(la10);
		
		preparePai(SWIDTH, SHEIGHT,pa11, ga11);
		la11 = new JLabel(new ImageIcon(pa11));
		la11.setBounds(1180,80,SWIDTH, SHEIGHT);
		p1.add(la11);
		
		preparePai(SWIDTH, SHEIGHT,pa12, ga12);
		la12 = new JLabel(new ImageIcon(pa12));
		la12.setBounds(1220,80,SWIDTH, SHEIGHT);
		p1.add(la12);
		
		preparePai(SWIDTH, SHEIGHT,pa13, ga13);
		la13 = new JLabel(new ImageIcon(pa13));
		la13.setBounds(1260,80,SWIDTH, SHEIGHT);
		p1.add(la13);
	
		b1 = new JButton("画像");
		b1.setBounds(20,145,80,20);
		p1.add(b1);
		b1.addActionListener(this);
		
		b2 = new JButton("認識");
		b2.setBounds(120,145,80,20);
		p1.add(b2);
		b2.addActionListener(this);
		
	
		ta1 = new JTextArea("");
		JScrollPane sc1 = new JScrollPane();
		sc1.setViewportView(ta1);
		sc1.setBounds(60,180,610,500);
		p1.add(sc1);
		
		ta2 = new JTextArea("");
		JScrollPane sc2 = new JScrollPane();
		sc2.setViewportView(ta2);
		sc2.setBounds(740,180,610,500);
		p1.add(sc2);
		
		getContentPane().add(p1, BorderLayout.CENTER);

		addWindowListener(new WindowClosing() );
	    setVisible(true);
	    setExtendedState(JFrame.MAXIMIZED_BOTH);
	}
	public void displayNewPai(){
		pa1 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa1,ga1);
		la1.setIcon(new ImageIcon(pa1));
		pa2 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa2,ga2);
		la2.setIcon(new ImageIcon(pa2));
		pa3 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa3,ga3);
		la3.setIcon(new ImageIcon(pa3));
		pa4 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa4,ga4);
		la4.setIcon(new ImageIcon(pa4));
		pa5 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa5,ga5);
		la5.setIcon(new ImageIcon(pa5));
		pa6 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa6,ga6);
		la6.setIcon(new ImageIcon(pa6));
		pa7 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa7,ga7);
		la7.setIcon(new ImageIcon(pa7));
		pa8 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa8,ga8);
		la8.setIcon(new ImageIcon(pa8));
		pa9 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa9,ga9);
		la9.setIcon(new ImageIcon(pa9));
		pa10 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa10,ga10);
		la10.setIcon(new ImageIcon(pa10));
		pa11 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa11,ga11);
		la11.setIcon(new ImageIcon(pa11));
		pa12 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa12,ga12);
		la12.setIcon(new ImageIcon(pa12));
		pa13 = new BufferedImage(SWIDTH, SHEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		preparePai(SWIDTH, SHEIGHT,pa13,ga13);
		la13.setIcon(new ImageIcon(pa13));
		
		image3 = new BufferedImage(PWIDTH, PHEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
		preparePai(PWIDTH, PHEIGHT,image3,g3);
		l3.setIcon(new ImageIcon(image3));
	}
	public void preparePai(int width, int height, BufferedImage img, Graphics g){
		
		g = img.createGraphics();
		g.setColor(Color.GRAY);
		g.fillRect(0,0,width, height);		
	}

	public void setPixel(int x, int y, int pixel, Graphics g){
		try {
			
	        int red = pixel >> 16 & 255;
	        int green = pixel >> 8 & 255;
	        int blue = pixel & 255;
	       
			g.setColor(new Color(red,green,blue));
			g.drawRect(x, y, 1, 1);
		} catch (Exception e){
		}
	}

	public class WindowClosing extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			int ans = JOptionPane.showConfirmDialog(JFrame1.this, "終了しますか？");
			if (ans == JOptionPane.YES_OPTION){
				System.exit(0);  
			}
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b1){
			//画像の選択		
			ta1.setText("");
			ta2.setText("");
			ukPai = 0;
			text = "";
			comment = "";
			
			String testImage ="";
			
			JFileChooser fc = new JFileChooser( "." );
			int result = fc.showOpenDialog( null );
			if(result==JFileChooser.APPROVE_OPTION) {
				testImage = fc.getSelectedFile().getPath();

			}
			if(result==JFileChooser.CANCEL_OPTION) {
			ta1.setText("画像の読み込みを取り消しました");
				return;
			}
			if(result==JFileChooser.ERROR_OPTION) {
			ta1.setText( "画像が開けません" );
				return;
			}
			ta1.setText("画像ファイル="+testImage);

			displayNewPai();
			
			image1 = null;
			try {image1 = ImageIO.read(new File(testImage));}
			catch (Exception e1) { e1.printStackTrace(); image1 = null;}
					
			PixelGrabber pg = new PixelGrabber(image1 , 0 , 0 , WIDTH, HEIGHT,pxd1,0,WIDTH);
			try { pg.grabPixels(); }
			catch (InterruptedException e2) { }
	
			l1.setIcon(new ImageIcon(image1));
			
			image2 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g2 = image2.createGraphics();

			l2.setIcon(new ImageIcon(image2));
			
			colorReduction1(WIDTH, HEIGHT, g2);
			l2.repaint();
			
			g4 = image4.createGraphics();
			g4.setColor(Color.GRAY);
			g4.fillRect(0,0,WIDTH,GHEIGHT);
			for (int i = 0; i < WIDTH; i++){
				g4.setColor(Color.WHITE);
				if (patternY[i] > 0){
					g4.drawRect(i,50-patternY[i], 1, patternY[i]);
				}
			}
			l4.repaint();
			
			
			g5 = image5.createGraphics();
			g5.setColor(Color.GRAY);
			g5.fillRect(0,0,GWIDTH,HEIGHT);
			for (int j = 0; j < HEIGHT; j++){
				g5.setColor(Color.WHITE);
				if (patternX[j] > 0){
					g5.drawRect(10,j,patternX[j]/7, 1);
				}
			}
			l5.repaint();
			text = "End of Distribution\n";
			ta1.setText(text);
			
			trim1(WIDTH,HEIGHT,g2);
			ta1.setText(text);
			
			l2.repaint();
			
			
		} else if (e.getSource() == b2){
			++ukPai;
			ta1.setText("");
			text = "";
			if (ukPai > NP) {
				ukPai=1;
				ta2.setText("");
				comment = "";
			}
			comment += "["+ ukPai + "]  ";
			text = "認識牌＝"+ukPai+"\n";

			String[] namePai= {"","一筒","二筒","三筒","四筒","五筒","六筒","七筒","八筒","九筒",
					"一萬","二萬","三萬","四萬","五萬","六萬","七萬","八萬","九萬",
					"一索","二索","三索","四索","五索","六索","七索","八索","九索",
					"東","南","西","北","發","中","白"};
			pWidth1 = frameW[ukPai];
			pHeight1 = frameH[ukPai];
			
			image3 = new BufferedImage(PWIDTH, PHEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g3 = image3.createGraphics();
			g3.setColor(Color.GRAY);
			g3.fillRect(0,0,PWIDTH, PHEIGHT);
			l3.setIcon(new ImageIcon(image3));

			trim2(frameX[ukPai], frameY[ukPai], pWidth1, pHeight1,g3);
			l3.repaint();
			
			eraseEdge1(pWidth1,pHeight1);
	
			minimize1(pWidth1,pHeight1);
			
			if (left2 < 0 || right2 < 0 || top2 < 0 || bottom2 < 0) {
				text += "「白」検出\n";
				//ta1.setText(text);
				No[1] = 34;
				No[2] = 34;
				No[3] = 34;
			} else {
			
				for (int id = 1; id < 34; id++){
				
					String src = sbPai[id];
					BufferedImage pai = null;
					
					try {pai = ImageIO.read(new File(src));}
					catch (Exception e2) {
						ta2.setText("error1"+e2.toString());
						pai = null;}
					PixelGrabber pg2 = new PixelGrabber(pai , 0 , 0 , SWIDTH, SHEIGHT,pxd6,0,SWIDTH);
					try { pg2.grabPixels(); }
					catch (InterruptedException e2) {
						ta2.setText("error2"+e2.toString());
					}
					
					colorReduction2(SWIDTH, SHEIGHT,ga7);
					
					minimize2(SWIDTH, SHEIGHT);
	
					reSize(pWidth2, pHeight2, pWidth3, pHeight3);
	
					recognize(pWidth2, pHeight2, id);
					double pr1 = Math.round(prob1[id]*100)/100;
					double pr2 = Math.round(prob2[id]*100)/100;
					double pr3 = Math.round(prob3[id]*100)/100;
					
					
					text += "("+id+")"+namePai[id]+"  認識率１=" + pr1 + "%   ,認識率２=" + pr2 
					     + "%  ,認識率３=" + pr3+"\n";
					
				}
				String result[];
				result = new String[NPAI];
				
				for (int i = 1; i < 34; i++){
					result[i] = "("+i+")prob1="+prob1[i]+",  prob2="+prob2[i]+",  prob3="+prob3[i];
					No[i] = i;
				}
				
				for (int i = 1; i < 33; i++){
					for (int j = i+1; j < 34; j++){
						if (prob3[i] < prob3[j]){
							double prob = prob3[j];
							prob3[j]= prob3[i];
							prob3[i]= prob;
							String result1 = result[j];
							result[j]=result[i];
							result[i]=result1;
							int No1 = No[j];
							No[j]= No[i];
							No[i]=No1;
							
						}
					}
				}
				
				
			}
			for (int i = 1; i < 4; i++){
				comment += "("+i+")"+namePai[No[i]]+"  ";
			}
			comment += "\n";
			ta2.setText(comment);
				
			
			ta1.setText(text);
			switch (ukPai){
			case 1:
				pa1 = null;
				try {pa1 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa1 = null;}
				la1.setIcon(new ImageIcon(pa1));
				break;
			case 2:
				pa2 = null;
				try {pa2 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa2 = null;}
				la2.setIcon(new ImageIcon(pa2));
				break;
			case 3:
				pa3 = null;
				try {pa3 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa1 = null;}
				la3.setIcon(new ImageIcon(pa3));
				break;
			case 4:
				pa4 = null;
				try {pa4 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa4 = null;}
				la4.setIcon(new ImageIcon(pa4));
				break;
			case 5:
				pa5 = null;
				try {pa5 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa5 = null;}
				la5.setIcon(new ImageIcon(pa5));
				break;
			case 6:
				pa6 = null;
				try {pa6 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa6 = null;}
				la6.setIcon(new ImageIcon(pa6));
				break;
			case 7:
				pa7 = null;
				try {pa7 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa7 = null;}
				la7.setIcon(new ImageIcon(pa7));
				break;
			case 8:
				pa8 = null;
				try {pa8 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa8 = null;}
				la8.setIcon(new ImageIcon(pa8));
				break;
			case 9:
				pa9 = null;
				try {pa9 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa9 = null;}
				la9.setIcon(new ImageIcon(pa9));
				break;
			case 10:
				pa10 = null;
				try {pa10 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa10 = null;}
				la10.setIcon(new ImageIcon(pa10));
				break;
			case 11:
				pa11 = null;
				try {pa11 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa11 = null;}
				la11.setIcon(new ImageIcon(pa11));
				break;
			case 12:
				pa12 = null;
				try {pa12 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa12 = null;}
				la12.setIcon(new ImageIcon(pa12));
				break;
			case 13:
				pa13 = null;
				try {pa13 = ImageIO.read(new File(saPai[No[1]]));}
				catch (Exception e2) {
					ta2.setText("error1"+e2.toString());
					pa13 = null;}
				la13.setIcon(new ImageIcon(pa13));
				break;
				
			}
		}
	}

    public void colorReduction1(int width, int height, Graphics g){
    	//未知画像の減色化
    	for (int x = 0; x < width; x++){
    		patternY[x] = 0;
    	}
    	for (int y = 0; y < height; y++){
    		patternX[y] = 0;
    	}
 		for (int y = 0; y < height; y++){
			for (int x = 0; x < width; x++){
				int pixel = pxd1[x + y * width];
		        int red   = (pixel >> 16) & 0xff;
			    int green = (pixel >>  8) & 0xff;
			    int blue  = (pixel      ) & 0xff;
			    int red1 = 0;
			    int green1 = 0;
			    int blue1 = 0;
			    
			    if (red > THR) red1 = 1;
			    if (green > THG) green1 = 1;
			    if (blue > THB) blue1 = 1;
			    
			    int px2 = red1*4+ green1*2 + blue1;
			    
			    
        		if (px2 == 1 || px2 == 5) blue1 = 0;
        		if (px2 == 3) {green1 =0; blue1 = 0; }
        		if (px2 == 6) blue1 = 1;
        		red = red1 * 255;
        		green = green1 * 255;
        		blue = blue1 * 255;
        		
        		pixel = red * 256 * 256 + green * 256 + blue;
        		pxd2[x + y * width]= pixel;
        		
        		g.setColor(new Color(red,green,blue));
    			g.drawRect(x, y, 1, 1);
        		
    			int px3 = red1*4+ green1*2 + blue1;
        		
    			if (px3 == BNC){
        			++patternX[y];
        			++patternY[x];
        		}
			}
			
		}
    }
    public void colorReduction2(int width, int height, Graphics g){
    	//標準画像の減色化
    	int x,y;
		for (y = 0; y < height; y++){
			for (x = 0; x < width; x++){
				int pixel = pxd6[x + y * width];
		        int red   = (pixel >> 16) & 0xff;
			    int green = (pixel >>  8) & 0xff;
			    int blue  = (pixel      ) & 0xff;
			    int red1 = 0;
			    int green1 = 0;
			    int blue1 = 0;
			    
			    if (red > THR) red1 = 1;
			    if (green > THG) green1 = 1;
			    if (blue > THB) blue1 = 1;
			    
			    int px2 = red1*4+ green1*2 + blue1;
			    
			    
        		if (px2 == 1 || px2 == 5) blue1 = 0;
        		if (px2 == 3) {green1 =0; blue1 = 0; }
        		if (px2 == 6) blue1 = 1;
        		red = red1 * 255;
        		green = green1 * 255;
        		blue = blue1 * 255;
        		
        		pixel = red * 256 * 256 + green * 256 + blue;
        		pxd6[x + y * width]= pixel;
			}
			
		}
    }
    
    public void trim1(int width, int height, Graphics g){
    	int sw = 0;
    	int k = 0;
    	int pat;
    	for (int i = 0; i < width; i++){
    		st1[i] = -1;
    		ed1[i] = -1;
    		if (patternY[i]==0)	text += "patternY["+i+"]="+patternY[i]+"\n";
    	}
    	
    	for (int x = 0; x < width; x++){
    		pat = patternY[x];
    		if (pat > 0 && sw == 0){
    			++k;
    			st1[k]= x;
    			text += "st1["+k+"]="+st1[k]+"\n";
    			sw = 1;
    		} else if (pat == 0 && sw == 1){
    			ed1[k] = x - 1;
    			text += "ed1[" + k + "]=" + ed1[k] + "\n";
    			sw = 0;
    		}
    	}
    	
    	if (st1[k] >=0 && ed1[k] < 0) {
    		ed1[k]= width - 1;
    		text += "ed1["+ k + "]=" +ed1[k] + "\n";
    	}
    	
    	ntX = k;
    	text += "ntX="+ntX+"\n";
    	
    	sw = 0;
    	k = 0;

     	for (int y = 0; y < height; y++){
    		pat = patternX[y];
    		if (pat > 0 && sw == 0){
    			++k;
    			st2[k]= y;
    			text += "st2["+k+"]="+st2[k]+"\n";
    			sw = 1;
    		} else if (pat == 0 && sw == 1){
    			ed2[k] = y - 1;
    			text += "ed2["+k+"]="+ed2[k]+"\n";
    			sw = 0;
    		}
    	}
    	
    	ntY = k;

    	int gapX = 0;
     	for (int i = 1; i < ntX; i++){
    		gapX += st1[i + 1]-ed1[i]-1;
     	}
    	
    	int lenX = ed1[ntX]- st1[1] - gapX + 1;
 
    	int pW = Math.round(lenX / NP);
    	text += "gapX="+ gapX + "\n";
    	text += "lenX="+ lenX + "\n";
    	text += "牌の横幅="+ pW + "\n";
    	
    	
    	int count = 0;
     	for (int i = 1; i <= ntX; i++){
    		int len1 = ed1[i]-st1[i]+1;
    		double num = (double)(len1)/(double)(pW);
    		long num1 = Math.round(num);
    		++count;
			frameX[count] = st1[i];
			frameW[count] = Math.round(len1 / num1);
			
			text += "frameX["+count+"]="+frameX[count]+", ";
			text += "frameW["+count+"]="+frameW[count]+"\n";

    		for (int j = 2; j <= num1; j++){
    			++count;
    			frameX[count] = st1[i]+ Math.round(len1 * (j - 1) / num1);
    			frameW[count] = frameX[count] - frameX[count-1]; 
    			
    			text += "frameX["+count+"]="+frameX[count]+", ";
    			text += "frameW["+count+"]="+frameW[count]+"\n";
      		}
		
		}
    	for (int i = 1; i <= NP; i++){
	     	top1 = -1;
			for (int y = 0; y < height/2; y++) {
		    	for (int x = frameX[i]; x < frameX[i] + frameW[i]; x++){
		    		if (pxd2[x + y * width] == WHITE && top1<0 ) {
			    		top1 = y;
			    		break;
		    		}
		   		}
			}
			
			bottom1 = -1;
			for (int y = height-1; y >= height/2; y--) {
				for (int x = frameX[i]; x < frameX[i] + frameW[i]; x++){
		    		if (pxd2[x + y * width] == WHITE && bottom1<0 ) {
				    	
		   				bottom1 = y;
		    			break;
		    		}
	    		}
			}
			frameY[i] = top1;
			frameH[i] = bottom1 - top1 +1;
  			text += "frameX["+i+"]="+frameX[i]+", ";
			text += "frameY["+i+"]="+frameY[i]+", ";
			text += "frameW["+i+"]="+frameW[i]+"\n";
			text += "frameH["+i+"]="+frameH[i]+"\n";
			

    	}
    	
		g.setColor(Color.RED);
		for (int i = 1; i <= NP; i++){
			g.drawRect(frameX[i], frameY[i], frameW[i], frameH[i]);
		}
		

   }
    
    public void trim2(int left,int top,int width,int height, Graphics g){
    	for (int y = 0; y < height; y++){
    		for (int x = 0; x < width; x++){
    			int pixel = pxd2[x+left+(y+top)*WIDTH];
    			setPixel(x,y,pixel,g);
    			pxd3[x + y * width]=pixel;
    		}
    	}

    }

    
    public void eraseEdge1(int width, int height){
    	for (int y = 0; y < height; y++){
    		for (int x = 0; x < width; x++){
    			int pixel = pxd3[x + y * width];
    			pxd4[x + y * width] = pixel; 
    		}
    	}
     	int left;
    	int right;
    	int top;
    	int bottom;
    	int x,y;
    	int white = 255*256*256+255*256+255;
    	for (y = 0 ;y < height; y++){
    		left = -1;
    		
    		for (x= 0; x < width; x++){
    			if(pxd3[x + y * width] == white) {
    				left = x; break;
    			}
     		}
    		for (x = 0; x < left; x++){
      			pxd4[x+y*width]= white;
    		}
    		right = width;
    		for (x = width-1; x >= 0; x--){
    			if(pxd3[x + y*width] == white) {
    				right = x; break;
    			}
    		}
    		for (x = width-1; x > right; x--){
    			pxd4[x+y*width]= white;
     		}
    	}
    	
    	for (x = 0 ;x < width; x++){
    		top = -1;
    		for (y = 0; y < height; y++){
    			if(pxd3[x + y* width] == white) {
    				top = y; break;
    			}
     		}
    		for (y = 0; y < top; y++){
    			pxd4[x+y*width]= white;
    		}
    		bottom = height;
    		for (y = height-1; y >= 0; y--){
    			if(pxd3[x + y*width] == white) {
    				bottom = y; break;
    			}
    		}
    		for (y = height-1; y> bottom; y--){
    			pxd4[x+y*width]= white;
     		}
    	}
    }
    
    public void minimize1(int width, int height){
    	//未知画像の最小化
     	left2 = -1;

		for (int x = 0; x < (int)(width/2); x++) {
	    		for (int y = 0 ; y < height; y++){
    			if (pxd4[x + y*width] != WHITE) {
    				left2 = x;
    				break;
    			}
    		}
    		if (left2 >= 0) break;
		}
	    if (left2 < 0) return;
	   
		right2 = -1;
		for (int x = width-1; x > (int)(width/2-1); x--) {
	    		for (int y = 0 ; y < 32; y++){
    			if (pxd4[x + y*width] != WHITE) {
    				right2 = x;
    				break;
    			}
    		}
    		if (right2 >= 0) break;
		}
		if (right2 < 0) return;
    	top2 = -1;
		for (int y = 0; y < (int)(height/2); y++) {
	    		for (int x = 0 ; x < width ; x++){
    			if (pxd4[x + y*width] != WHITE) {
    				top2 = y;
    				break;
    			}
    		}
    		if (top2 >= 0) break;
		}
	    if (top2 < 0) return;		
		bottom2 = -1;
		for (int y = height-1; y > (int)(height/2-1); y--) {
	    		for (int x = 0 ; x < width; x++){
    			if (pxd4[x + y*width] != WHITE) {
    				bottom2 = y;
    				break;
    			}
    		}
    		if (bottom2 >= 0) break;
		}
		if (bottom2 < 0) return;
    	    	
		pWidth2 = right2 - left2 +1;
		pHeight2 = bottom2 - top2 +1;
		for (int y = 0; y < pHeight2; y++){
			for (int x = 0; x < pWidth2; x++){
				int pixel = pxd4[x + left2 +(y + top2) * width];
				pxd5[x + y * pWidth2] = pixel;
			}
		}

    }
    
    public void minimize2(int width, int height){
     	//標準画像の最小化
     	left3 = -1;
    	int white = 255*256*256+255*256+255;
		for (int x = 0; x < (int)(width/2); x++) {
	    		for (int y = 0 ; y < height; y++){
    			if (pxd6[x + y*width] != white) {
    				left3 = x;
    				break;
    			}
    		}
    		if (left3 >= 0) break;
		}
	    if (left3 < 0) left3 = (int)(width/4);		
		right3 = -1;
		for (int x = width-1; x > (int)(width/2-1); x--) {
	    		for (int y = 0 ; y < 32; y++){
    			if (pxd6[x + y*width] != white) {
    				right3 = x;
    				break;
    			}
    		}
    		if (right3 >= 0) break;
		}
		if (right3 < 0) right3 = (int)(width*3/4);
    	top3 = -1;
		for (int y = 0; y < (int)(height/2); y++) {
	    		for (int x = 0 ; x < width ; x++){
    			if (pxd6[x + y*width] != white) {
    				top3 = y;
    				break;
    			}
    		}
    		if (top3 >= 0) break;
		}
	    if (top3 < 0) top3 = (int)(height/4);		
		bottom3 = -1;
		for (int y = height-1; y > (int)(height/2-1); y--) {
	    		for (int x = 0 ; x < width; x++){
    			if (pxd6[x + y*width] != white) {
    				bottom3 = y;
    				break;
    			}
    		}
    		if (bottom3 >= 0) break;
		}
		if (bottom3 < 0) bottom3 = (int)(height*3/4);
    	    	
		pWidth3 = right3 - left3 +1;
		pHeight3 = bottom3 - top3 +1;
		for (int y = 0; y < pHeight3; y++){
			for (int x = 0; x < pWidth3; x++){
				int pixel = pxd6[x + left3 +(y + top3) * width];
				pxd7[x + y * pWidth3] = pixel;
			}
		}

    }
    
    public void reSize(int width1, int height1, int width2, int height2){
    	for (int y = 0 ; y < height2 ; y++){
    		for (int x = 0; x < width2 ; x++ ){
     			int x1 = x*(width1-1)/(width2-1);
    			int y1 = y*(height1-1)/(height2-1);
    			int pixel = pxd7[x + y * width2];
    			pxd8[x1 + y1 * width1] = pixel;
    		}
		}
    }
    
    public void recognize(int width, int height, int id){
	   //認識率
		int score1 = 0;
		int score2 = 0;

		for (int y = 1 ; y < height-1 ; y++){
			for (int x = 1; x < width-1 ; x++ ){
				if (pxd5[x + y * width] == pxd8[ x + y * width] ) ++score1;
				if ((pxd5[x + y * width] != WHITE && pxd8[ x + y * width] != WHITE)||
				 (pxd5[x + y * width] == WHITE && pxd8[ x + y * width] == WHITE)) ++score2;
			}
		}
		prob1[id] = (double)score1*100.0/((double)width * (double)height);
		prob2[id] = (double)score2*100.0/((double)width * (double)height);
		prob3[id] = RATE * prob1[id]+ (1-RATE)* prob2[id];
		
    }
 }
